unit Childwin;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, StdCtrls,
  openMsg, MXMAILX;

{$I mailxdef.int}

type
  TMDIChild = class(TForm)
    MsgList: TListBox;
    btnHide: TButton;
    btnOpenMsg: TButton;
    btnRefresh: TButton;
    btnSort: TCheckBox;
    btnUnread: TCheckBox;
    MXMessage1: TMXMessage;
    MXForm1: TMXForm;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnHideClick(Sender: TObject);
    procedure btnRefreshClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnOpenMsgClick(Sender: TObject);
    procedure NewMsgWnd;
    procedure MsgListDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}


procedure TMDIChild.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TMDIChild.btnHideClick(Sender: TObject);
begin
     Close;
end;

procedure TMDIChild.btnRefreshClick(Sender: TObject);
begin
     if BtnUnread.State=cbChecked then MXMessage1.UnreadOnly:=TRUE
     else MXMessage1.UnreadOnly:=FALSE;

     if BtnSort.State=cbChecked then MXMessage1.SortMsg:=TRUE
     else MXMessage1.SortMsg:= FALSE;
     MsgList.Clear;
     MXMessage1.Action:= ACTION_FINDFIRST;

     While MXMessage1.FetchMsg <> 0 Do
     begin
          MsgList.Items.Add(MXMessage1.Subject);
          MXMessage1.Action:= ACTION_FINDNEXT;
     end;
end;

procedure TMDIChild.FormCreate(Sender: TObject);
begin
     btnRefreshClick(Self);
end;

procedure TMDIChild.btnOpenMsgClick(Sender: TObject);
var
   Index: Integer;
begin
     Index:= MsgList.ItemIndex;
     if Index=-1 then
     begin
          Application.MessageBox('Select a Mail Message from List',
                                 'Mail X Demo for DELPHI',
                                 MB_ICONSTOP);
     end
     else
     begin
          MXMessage1.FetchMsg:=Index+1;
          NewMsgWnd;
     end;

end;


procedure TMDIChild.NewMsgWnd;
var
   Child: TMsgForm;
   FileNum: Integer;
   Index: Integer;
begin
  Child := TMsgForm.Create(Application);
  Child.MXMessage1.MsgID:=MXMessage1.MsgID;
  Child.szSubject.Text:=Child.MXMessage1.Subject;
  Child.szNoteText.Lines:=Child.MXMessage1.NoteText;
  Child.szTime.Text:=Child.MXMessage1.TimeReceived;
  Child.szMessageID.Text:=Child.MXMessage1.MsgID;

  Child.MXRecipient1.ObjRef:=Child.MXMessage1.ObjRef;
  Child.szOriginator.Text:=Child.MXRecipient1.RecipientName;

  Child.MXFile1.ObjRef:= Child.MXMessage1.ObjRef;
  FileNum:= Child.MXFile1.FileCount;

  For Index:= 1 To FileNum do
  begin
      Child.MXFile1.FileNum:= Index;
      Child.szAttachList.Items.Add(Child.MXFile1.FileName);
  end;
  If FileNum > 0 Then Child.szAttachList.ItemIndex:= 0;

end;


procedure TMDIChild.MsgListDblClick(Sender: TObject);
begin
     btnOpenMsgClick(Sender);
end;

end.
